// @TOOD change this file name
<template>
  <div id="technologic-card-form">

    <input type="text" v-model="technologic_card_object.number" placeholder="number" />
    <input type="file" id="myFile" name="filename" ref=fileInput @change="onFilePicked">
    <button @click="CreateTechnologicCard">{{submit_text}}</button>

    <span id="error_message">{{error_message}}</span>
  </div>
</template>

<script>
import { setAuthorizationToken } from "../../utils/authUtils";
import { createDataBaseObject, putDataBaseObject, getTechnologicCardById } from "../../utils/apiUtils";
import router from "../../router";

const technologic_cards_url = "http://127.0.0.1:8000/handlings/technologic_card/";

export default {
  name: "TechnologicCardCreate",
  props: {
    initial_object : Object,
    after_post_callback : Function
  },
  data: function() {
    return {
      technologic_card_object:{
          number: "",
          pdf_card: null
      },

      submit_text: "Create",
      error_message: ""
    };
  },
  methods: {
    TechnologicCardObjectClear() {
        this.technologic_card_object = {
            number: "",
            pdf_card: null
      };
    },
    CreateTechnologicCard() {
        (async () => {
            try {
              const formData = new FormData();
              formData.append("number", this.technologic_card_object.number)
              formData.append("pdf_card", this.technologic_card_object.pdf_card, this.technologic_card_object.pdf_card.name)


              if (this.submit_text == "Create") {
                await createDataBaseObject(technologic_cards_url, formData, "technologic_card");
                this.TechnologicCardObjectClear();
              } else if (this.submit_text == "Edit") {
                await putDataBaseObject(technologic_cards_url + this.initial_object.id + "/", formData, "technologic_card");
              }
              this.after_post_callback?.();
            } catch (error) {
                this.error_message = error;
            }
        })();
    },
    onFilePicked(event) {
      this.technologic_card_object.pdf_card = event.target.files[0]
    },
    specChanged() {},
  },

  mounted: function() {
    if (this.initial_object) {
      this.technologic_card_object = this.initial_object;
      this.submit_text = "Edit";
    }
  }
};
</script>

<style scoped>
/* @TODO do something with this styles!!! - make it global or something */
#technologic-card-form {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-left: 40%;
  margin-right: 40%;
}
input {
  width: 100%;
  padding: 12px 20px;
  margin: 8px 0;
  border: 1px solid #ccc;
  border-radius: 4px;
  box-sizing: border-box;
  text-align: center;
}
#error_message {
  color: red;
}
</style>>